/**
* Script: bullet.js
* Written by: Radnen
* Updated: 7/7/2013
**/

var bullets = [];
var bullet_num = 0;

function CreateBullet(hero)
{
    var d = GetPersonDirection(hero);
    var x = 0, y = 0;
    switch(d) {
        case "north": y = -1; break;
        case "south": y = 1; break;
        case "west": x = -1; break;
        case "east": x = 1; break;
		case "northeast": x = 1; y = -1; break;
		case "northwest": x = -1; y = -1; break;
		case "southeast": x = 1; y = 1; break;
		case "southwest": x = -1; y = 1; break;
    }

	bullet_num++;
    bullets.push(new Bullet("bullet: " + bullet_num, GetPersonX(hero) + x * 16, GetPersonY(hero) + y * 16, x, y));
}

function Bullet(name, start_x, start_y, vel_x, vel_y)
{
    this.name = name;
    this.xVelocity = vel_x;
    this.yVelocity = vel_y;
    this.speed = 2;

    CreatePerson(name, "bullet.rss", true); // name of this bullet;
    SetPersonX(name, start_x);
    SetPersonY(name, start_y);
}

Bullet.prototype.update = function() {
    var x = GetPersonX(this.name) + this.xVelocity * this.speed;
    var y = GetPersonY(this.name) + this.yVelocity * this.speed;

    SetPersonX(this.name, x);
    SetPersonY(this.name, y);

	var mw = GetLayerWidth(0) * GetTileWidth();
	var mh = GetLayerHeight(0) * GetTileHeight();
	
    if (IsPersonObstructed(this.name, x, y) || x < 0 || y < 0 || x > mw || y > mh) {
        this.dead = true;
        var name = GetObstructingPerson(this.name, x, y);
        if (name != "") {
            // here we have an obstructing entity..
        }
    }
}

function UpdateBullets()
{
    for (var i = 0; i < bullets.length; ++i) {
        bullets[i].update();
        if (bullets[i].dead) { DestroyPerson(bullets[i].name); bullets.splice(i, 1); i--; }
    }
}